#include "prefix.h"



#define WIN32_LEAN_AND_MEAN

DisableWarnings (
  4480 // nonstandard extension used
  4514 // unref inline removed
  4710 // function not inlined
  4711 // selected for automatic inline expansion
  4820 // padding
  4996 // deprecated funcs
)


DisableWarningsPush (4091 4201 4365 4668 4826 4917)

#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_NONSTDC_NO_DEPRECATE
#define STRSAFE_NO_DEPRECATE

#include <windows.h>
#include <commctrl.h>
#include <mmreg.h>
#include <dshow.h>
#include <ks.h>
#include <ksmedia.h>
#include <audiomediatype.h>

//#pragma warning (disable: Warnings_FromForeignHeaders)

#include <stddef.h>
#include <stdlib.h>
#include <limits.h>

#define _USE_MATH_DEFINES
#include <math.h>

PopWarnings ()



//DisableWarnings (Warnings_UnsafeFunctions Warnings_FunctionNotInlined Warnings_Deprecated)

#if _Debug

  //DisableWarnings (Warnings_InlineFunctions)

#endif



#define _StrX(x) #x
#define _S(x) _StrX (x)



// Convert ANSI string literal to UNICODE

#define _UStrX2(x) L ## x
#define _UT(x) _UStrX2 (x)
#define _T(x) _UStrX2 (x)



#define SetBits(v,m) ((v) |= (m))
#define ClearBits(v,m) ((v) &= ~(m))
#define TestBits(e,m) ((e) & (m))



#if _MSC_VER < 1800

  #define nullptr 0

#endif


//typedef void const * PCVOID;
//typedef BYTE const * PCBYTE;



#define FakeCopyConstructor(C) C (C const & Src);
#define FakeAssignmentOperator(C) void operator = (C const & Src);



#define NumArrayElems(a) (sizeof (a) / sizeof (*(a)))
#define SizeOfArray NumArrayElems
#define StrSzToLen(Size) ((Size) / sizeof (TCHAR))
#define StrLenToSz(Len) ((Len) * sizeof (TCHAR))
#define IsInRange(v, min, max) ((v) >= (min) && (v) <= (max))



#define While(Cond) \
  __pragma (warning (push)) \
  __pragma (warning (disable: 4127)) \
  while (Cond) \
  __pragma (warning (pop)) \

#define WhileFalse While (false)
#define OnlyOnce While (false)
#define WhileTrue While (true)
#define DoForever While (true)

#define Unreferenced(...) (void) (__VA_ARGS__)



#define ZeroObject(o) RtlZeroMemory (&(o), sizeof (o))


#define HRESULT_FROM_REG(r) HRESULT_FROM_WIN32 (static_cast <UINT> (r))


static HRESULT const E_I_PROCESSING_NOT_FINISHED = HRESULT (-1);



#if _Debug

  #define Assert(Condition) \
    if (!(Condition)) { \
      __debugbreak (); \
    }

  #define AssertIf(_if,_then) Assert (!(_if) || (_then))
  #define AssertInRange(v, min, max) Assert (IsInRange (v, min, max))

  #define Verify Assert

  #define IfDebug(...) __VA_ARGS__

  #define Debug DebugPrintf

  void SetDebugPrintLevel (UINT const Level);
  void DebugVPrintf (UINT const Level, PCTSTR const _Fmt, va_list const List);

#else

  #define Assert(Condition)
  #define AssertIf(_if,_then)
  #define AssertInRange(v, min, max)
  #define Verify(Condition) ((void *) (Condition))

  #define Debug(Level, ...) DebugPrintf ()

  void __forceinline DebugPrintf () { }

  #define IfDebug(...)

#endif



#define DebugPatch \
  __pragma (message (__FILE__ " (" _S (__LINE__) "): warning - DebugPatch in use! ####################")) \


extern "C" void * _AddressOfReturnAddress ();
__pragma (intrinsic (_AddressOfReturnAddress))





#include "resource.h"





#include "..\filter\DsOverAsio.h"
using namespace DsOverAsio;

#include "params.h"





#define PointerCast(t, p) (static_cast <t> (static_cast <void *> (p)))





static const UINT WM_DirectShowNotification = WM_APP + 1;





#if _Debug

  void DebugVPrintf (UINT const Level, PCTSTR const _Fmt, va_list const List);
  void _cdecl DebugPrintf (UINT const Level, PCTSTR const _Fmt, ...);
  void SetDebugPrintLevel (UINT const Level);

#endif





#include "misc.h"





wchar_t inline CharToUpper (wchar_t const c) {

  return (
    reinterpret_cast <UINT_PTR> (
      CharUpper (
       reinterpret_cast <PTSTR> (static_cast <UINT_PTR> (static_cast <WORD> (c)))
      )
    )
  ) & 0xffff;

}





#if _Debug

  extern UINT DebugPrintLevel;

#endif

extern HWND MainDlg;
